/**********************************************************************
 *                     Berliner Uhr
 *                   ================
 *                   Uwe Berger; 2009
 * 
 * Die Kommandozeilenversion mit ncurses.
 * 
 * ---------
 * Have fun!
 * 
 **********************************************************************/
#include <time.h>
#include <curses.h>

int current_getch;
int doloop = 1;
static WINDOW *mainwnd;

int now_s, now_m, now_h;
time_t now;
struct tm *now_tm;
	
//**********************************************************************
void screen_init(void) {
	int i;
	mainwnd = initscr();
	noecho();
	cbreak();
	nodelay(mainwnd, TRUE);
	refresh();
	wrefresh(mainwnd);
	// Rahmen zeichnen
	mvaddch(0, 0, ACS_ULCORNER);
	mvaddch(0, 12, ACS_URCORNER);
	mvaddch(6, 0, ACS_LLCORNER);
	mvaddch(6, 12, ACS_LRCORNER);
	for (i=1; i<6; i++) {
		mvaddch(i, 0, ACS_VLINE);
		mvaddch(i, 12, ACS_VLINE);
	}
	for (i=1; i<12; i++) {
		mvaddch(0, i, ACS_HLINE);
		mvaddch(6, i, ACS_HLINE);
	}
	// Farben initialisieren
	start_color();
	init_pair(1, COLOR_YELLOW, COLOR_BLACK);
	init_pair(2, COLOR_RED, COLOR_BLACK);
}

//**********************************************************************
static void update_screen(void) {
	int i;
	// aktuelle Uhrzeit
	now = time (NULL);
	now_tm	= localtime (&now);
    now_s	= now_tm->tm_sec;
	now_m	= now_tm->tm_min;
	now_h	= now_tm->tm_hour;
	curs_set(0);
	// Sekundenanzeige
	color_set(1, 0);
	if(now_s % 2) mvaddch(1, 6, ' '); else mvaddch(1, 6, ACS_CKBOARD);
	// Sonderegelung 24:00 Uhr
	if ((now_h==0)&&(now_m==0)) now_h = 24;
	// 5er Stunden
	color_set(2, 0);
	for (i=0; i<4; i++) {
		if (now_h/((i+1)*5)) {
			mvaddch(2, i*3+1, ACS_CKBOARD);
			mvaddch(2, i*3+2, ACS_CKBOARD);
		} else {
			mvaddch(2, i*3+1, ' ');
			mvaddch(2, i*3+2, ' ');
		}
	}
	// 1er Stunden
	color_set(2, 0);
	for (i=0; i<4; i++) {
		if ((now_h%5)>i) {
			mvaddch(3, i*3+1, ACS_CKBOARD);
			mvaddch(3, i*3+2, ACS_CKBOARD);
		} else {
			mvaddch(3, i*3+1, ' ');
			mvaddch(3, i*3+2, ' ');
		}
	}
	// 5er Minuten
	for (i=0; i<11; i++) {
		// jedes dritte Zeichen in Rot...
		if ((i+1)%3) color_set(1, 0); else color_set(2, 0);
		if (now_m/((i+1)*5)) mvaddch(4, i+1, ACS_CKBOARD); else mvaddch(4, i+1, ' ');
	}
	// 1er Minuten
	color_set(1, 0);
	for (i=0; i<4; i++) {
		if ((now_m%5)>i) {
			mvaddch(5, i*3+1, ACS_CKBOARD); 
			mvaddch(5, i*3+2, ACS_CKBOARD); 
		} else {
			mvaddch(5, i*3+1, ' ');
			mvaddch(5, i*3+2, ' '); 
		}
	}
	refresh();
}

//**********************************************************************
//**********************************************************************
//**********************************************************************
int main(void) {
   screen_init();
   // solange bis Ende-Taste...
   while (doloop) {
      // Tastaturabfrage
      current_getch = getch();
      // 'q' gedrueckt?
      if (current_getch == 113) {
         doloop = 0;
      }
      // Bildschirm aktualisieren
      update_screen();
      // eine Sekunde warten
      sleep(1);
   }
   endwin();
   // was ich schon immer sagen wollte :-)...
   printf("Berliner Uhr (ncurses-Version); Uwe Berger; 2009\n");
   return 0;
}




